=begin
#Coinmarketcap API Swagger Implementation

#Define coinmarketcap's api in swagger 2.0 openapi standard

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.4

=end

require 'date'

module CoinmarketcapClient
  # Global metrics object
  class GlobalMetricsQuotesLatest
    attr_accessor :btc_dominance

    attr_accessor :eth_dominance

    attr_accessor :active_cryptocurrencies

    attr_accessor :active_market_pairs

    attr_accessor :active_exchanges

    attr_accessor :last_updated

    attr_accessor :quote

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'btc_dominance' => :'btc_dominance',
        :'eth_dominance' => :'eth_dominance',
        :'active_cryptocurrencies' => :'active_cryptocurrencies',
        :'active_market_pairs' => :'active_market_pairs',
        :'active_exchanges' => :'active_exchanges',
        :'last_updated' => :'last_updated',
        :'quote' => :'quote'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'btc_dominance' => :'Float',
        :'eth_dominance' => :'Float',
        :'active_cryptocurrencies' => :'Integer',
        :'active_market_pairs' => :'Integer',
        :'active_exchanges' => :'Integer',
        :'last_updated' => :'DateTime',
        :'quote' => :'Hash<String, GlobalMetricsQuote>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'btc_dominance')
        self.btc_dominance = attributes[:'btc_dominance']
      end

      if attributes.has_key?(:'eth_dominance')
        self.eth_dominance = attributes[:'eth_dominance']
      end

      if attributes.has_key?(:'active_cryptocurrencies')
        self.active_cryptocurrencies = attributes[:'active_cryptocurrencies']
      end

      if attributes.has_key?(:'active_market_pairs')
        self.active_market_pairs = attributes[:'active_market_pairs']
      end

      if attributes.has_key?(:'active_exchanges')
        self.active_exchanges = attributes[:'active_exchanges']
      end

      if attributes.has_key?(:'last_updated')
        self.last_updated = attributes[:'last_updated']
      end

      if attributes.has_key?(:'quote')
        if (value = attributes[:'quote']).is_a?(Hash)
          self.quote = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          btc_dominance == o.btc_dominance &&
          eth_dominance == o.eth_dominance &&
          active_cryptocurrencies == o.active_cryptocurrencies &&
          active_market_pairs == o.active_market_pairs &&
          active_exchanges == o.active_exchanges &&
          last_updated == o.last_updated &&
          quote == o.quote
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [btc_dominance, eth_dominance, active_cryptocurrencies, active_market_pairs, active_exchanges, last_updated, quote].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CoinmarketcapClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
